%-----------------------
%Calcular el centre de gravetat del vehicle en funci de la posici del
%bra.
%Els parmetres necessris per a aquest clcul sn la posici angular de
%cada articulaci, la fora externa (les variables X, Y i Z, ja que
%augmenten la "massa" de l'extrem del bra) i els parmetres del bra com
%del submar.

%Parmetres
%--------------------------------------------------------------------------
%Gravetat
g=9.81;
%Massa submar, manipulable desde interfcie grfica
mSub=300;

%Dimensions Submar, manipulable desde interfcie grfica
lon=1.5;
al=0.75;
amp=1;

%Posici del bra en el robot, respecte el sistema de referncia del robot
XArm=[lon/2,0,al/2];


%Massa links bra, aquestes masses han de ser modificables respecte la
%interfcie grfica.
mArm=[5,3,2,0,1];

%Longitud dels links, han de ser modificables respecte la interfcie
%grfica.
lArm=[[0;0;0],[0;0;0],[0;0;0],[0;0;0],[0;0;0]];

%Fi parmetres
%--------------------------------------------------------------------------

%Calculem les matrius i-1Ai que es calculen a la funci directaQ
%-------------------------
Q=[10,20,30,90,50];
GO=[0;0;0;0;0;0];



Q=pi/180*Q;
%Denavit hartenberg
%Parametres

Theta=[Q(1),Q(2),Q(3),Q(4),Q(5)];
Adist=[0.05,0.2,0.1,0,0];
Ddist=[0.05,0,0,0,0.02];
Alfa=([90*pi/180,0,0,90/180*pi,0]);
Home=pi/180*([0,0,90*pi/180,0,-90*pi/180]);
%Theta,d,a,alfa,home

DoF1=[Theta(1),Ddist(1),Adist(1),Alfa(1),Home(1)];
DoF2=[Theta(2),Ddist(2),Adist(2),Alfa(2),Home(2)];
DoF3=[Theta(3),Ddist(3),Adist(3),Alfa(3),Home(3)];
DoF4=[Theta(4),Ddist(4),Adist(4),Alfa(4),Home(4)];
DoF5=[Theta(5),Ddist(5),Adist(5),Alfa(5),Home(5)];


%Matrius (i-1)A(i)
A1=[cos(Theta(1)),-cos(DoF1(4))*sin(Theta(1)), sin(DoF1(4))*sin(Theta(1)),DoF1(3)*cos(Theta(1)); sin(Theta(1)), cos(DoF1(4))*cos(Theta(1)), -sin(DoF1(4))*cos(Theta(1)),DoF1(3)*sin(Theta(1));0, sin(DoF1(4)),cos(DoF1(4)),DoF1(2);0,0,0,1];
A2=[cos(Theta(2)),-cos(DoF2(4))*sin(Theta(2)), sin(DoF2(4))*sin(Theta(2)),DoF2(3)*cos(Theta(2)); sin(Theta(2)), cos(DoF2(4))*cos(Theta(2)), -sin(DoF2(4))*cos(Theta(2)),DoF2(3)*sin(Theta(2));0, sin(DoF2(4)),cos(DoF2(4)),DoF2(2);0,0,0,1];
A3=[cos(Theta(3)),-cos(DoF3(4))*sin(Theta(3)), sin(DoF3(4))*sin(Theta(3)),DoF3(3)*cos(Theta(3)); sin(Theta(3)), cos(DoF3(4))*cos(Theta(3)), -sin(DoF3(4))*cos(Theta(3)),DoF3(3)*sin(Theta(3));0, sin(DoF3(4)),cos(DoF3(4)),DoF3(2);0,0,0,1];
A4=[cos(Theta(4)),-cos(DoF4(4))*sin(Theta(4)), sin(DoF4(4))*sin(Theta(4)),DoF4(3)*cos(Theta(4)); sin(Theta(4)), cos(DoF4(4))*cos(Theta(4)), -sin(DoF4(4))*cos(Theta(4)),DoF4(3)*sin(Theta(4));0, sin(DoF4(4)),cos(DoF4(4)),DoF4(2);0,0,0,1];
A5=[cos(Theta(5)),-cos(DoF5(4))*sin(Theta(5)), sin(DoF5(4))*sin(Theta(5)),DoF5(3)*cos(Theta(5)); sin(Theta(5)), cos(DoF5(4))*cos(Theta(5)), -sin(DoF5(4))*cos(Theta(5)),DoF5(3)*sin(Theta(5));0, sin(DoF5(4)),cos(DoF5(4)),DoF5(2);0,0,0,1];

%Matrius de transformaci
A01=A1;
A02=A01*A2;
A03=A02*A3;
A04=A03*A4;
A05=A04*A5;

%Matrius de rotaci
R01=A01(1:3,1:3);
R02=A02(1:3,1:3);
R03=A03(1:3,1:3);
R04=A04(1:3,1:3);
R05=A05(1:3,1:3);
%--------------------------


%A partir de les matrius anterior s'obt la posici de cada element
%terminal respecte la base del mateix bra
Base=[0;0;0];
Art1=A01(1:3,4);
Art2=A02(1:3,4);
Art3=A03(1:3,4);
Art4=A04(1:3,4);
Art5=A05(1:3,4);

%Es calcula la posici del centre de gravetat de tot el bra suposant que
%cada element te el seu centre de masses al mig de la longitud del link
CdG1=Base+R01*lArm(:,1);
CdG2=Art1+R02*lArm(:,2);
CdG3=Art2+R03*lArm(:,3);
CdG4=Art3+R04*lArm(:,4);
CdG5=Art4+R05*lArm(:,5);

%Es calcula els valors de fora en els 3 eixos del submar
%Aquests es poden trobar a la matriu GO definida en el clcul de esforos
%sobre el submar resultat de sumar gravetat ms flotabilitat, se
%n'extreuran els 3 primers valors.
FMSub=GO(1:3);

%Clcul del centre de gravetat mitjanant moments respecte la base del
%robot, punt situat a XArm=[lon/2,0,al/2];
Xcdg=(-FMSub(1)*XArm(1)+g*(CdG1(1)*mArm(1)+CdG2(1)*mArm(2)+CdG3(1)*mArm(3)+CdG4(1)*mArm(4)+CdG5(1)*mArm(5)))/(FMSub(1)+g*(mArm(1)+mArm(2)+mArm(3)+mArm(4)+mArm(5)));
Ycdg=(-FMSub(2)*XArm(2)+g*(CdG1(2)*mArm(1)+CdG2(2)*mArm(2)+CdG3(2)*mArm(3)+CdG4(2)*mArm(4)+CdG5(2)*mArm(5)))/(FMSub(2)+g*(mArm(1)+mArm(2)+mArm(3)+mArm(4)+mArm(5)));
Zcdg=(-FMSub(3)*XArm(3)+g*(CdG1(3)*mArm(1)+CdG2(3)*mArm(2)+CdG3(3)*mArm(3)+CdG4(3)*mArm(4)+CdG5(3)*mArm(5)))/(FMSub(1)+g*(mArm(1)+mArm(2)+mArm(3)+mArm(4)+mArm(5)));

%Sortida "CDGglobal"
%-----------------------