%Definim la funcio DibuixaArm, que ens far una representaci grfica del bra
%robotitzat 
function DibuixaArmRad(Q);

% Apliquem Denavit Hartenberg i les matrius per saber la posici final de
% l'element, on Q(i) s'extreu de la posici actual obtinguda a partir
% d'integraci de la acceleraci i velocitat

%Denavit hartenberg
%Parametres

Theta=[Q(1),Q(2),Q(3),Q(4),Q(5)];
Adist=[0.05,0.2,0.1,0,0];
Ddist=[0.05,0,0,0,0.02];
Alfa=([-90*pi/180,0,-90*pi/180,90/180*pi,-90*pi/180]);
Home=pi/180*([0,0,90*pi/180,0,-90*pi/180]);
%Theta,d,a,alfa,home

DoF1=[Theta(1),Ddist(1),Adist(1),Alfa(1),Home(1)];
DoF2=[Theta(2),Ddist(2),Adist(2),Alfa(2),Home(2)];
DoF3=[Theta(3),Ddist(3),Adist(3),Alfa(3),Home(3)];
DoF4=[Theta(4),Ddist(4),Adist(4),Alfa(4),Home(4)];
DoF5=[Theta(5),Ddist(5),Adist(5),Alfa(5),Home(5)];


%Matrius (i-1)A(i)
A1=[cos(Theta(1)),-cos(DoF1(4))*sin(Theta(1)), sin(DoF1(4))*sin(Theta(1)),DoF1(3)*cos(Theta(1)); sin(Theta(1)), cos(DoF1(4))*cos(Theta(1)), -sin(DoF1(4))*cos(Theta(1)),DoF1(3)*sin(Theta(1));0, sin(DoF1(4)),cos(DoF1(4)),DoF1(2);0,0,0,1];
A2=[cos(Theta(2)),-cos(DoF2(4))*sin(Theta(2)), sin(DoF2(4))*sin(Theta(2)),DoF2(3)*cos(Theta(2)); sin(Theta(2)), cos(DoF2(4))*cos(Theta(2)), -sin(DoF2(4))*cos(Theta(2)),DoF2(3)*sin(Theta(2));0, sin(DoF2(4)),cos(DoF2(4)),DoF2(2);0,0,0,1];
A3=[cos(Theta(3)),-cos(DoF3(4))*sin(Theta(3)), sin(DoF3(4))*sin(Theta(3)),DoF3(3)*cos(Theta(3)); sin(Theta(3)), cos(DoF3(4))*cos(Theta(3)), -sin(DoF3(4))*cos(Theta(3)),DoF3(3)*sin(Theta(3));0, sin(DoF3(4)),cos(DoF3(4)),DoF3(2);0,0,0,1];
A4=[cos(Theta(4)),-cos(DoF4(4))*sin(Theta(4)), sin(DoF4(4))*sin(Theta(4)),DoF4(3)*cos(Theta(4)); sin(Theta(4)), cos(DoF4(4))*cos(Theta(4)), -sin(DoF4(4))*cos(Theta(4)),DoF4(3)*sin(Theta(4));0, sin(DoF4(4)),cos(DoF4(4)),DoF4(2);0,0,0,1];
A5=[cos(Theta(5)),-cos(DoF5(4))*sin(Theta(5)), sin(DoF5(4))*sin(Theta(5)),DoF5(3)*cos(Theta(5)); sin(Theta(5)), cos(DoF5(4))*cos(Theta(5)), -sin(DoF5(4))*cos(Theta(5)),DoF5(3)*sin(Theta(5));0, sin(DoF5(4)),cos(DoF5(4)),DoF5(2);0,0,0,1];
%Definim les matrius necessaries per a fer el PLOT.
A1=A1;
A12=A1*A2;
A13=A12*A3;
A14=A13*A4;
A15=A14*A5;

%fem el PLOT per a qu es vegi la trajectria que est seguin el bra.
clf(figure(1));
axis([-0.5 0.5 -0.5 0.5 0 0.5])
%Dibuixem primer el link i llavors els eixox de referncia
line([0;A1(1,4)],[0;A1(2,4)],[0;A1(3,4)],'color','c','LineWidth',2);
%Es dibuixen els eixos de coordenades de la articulaci 1, que coincideix amb
%els del mn i que sempre sn fixes. Sn els eixos de referncia
%Es dibuixa l'eix z
line([0 0],[0 0],[0 0.05], 'color','r','LineWidth',1);
%Es dibuixa l'eix x
line([0 0.05],[0 0],[0 0], 'color','b','LineWidth',1);
%Es dibuixa l'eix y
line([0 0],[0 0.05],[0 0], 'color','g','LineWidth',1);
%Es calcula l'estat dels eixos de l'articulaci 2, per tant cal
%multiplicar la matriu que relaciona l'eix de coordeandes de l'articulacio
%2 amb l'eix de cooredenades del mn, per el punt on acabava cada eix de
%coordenades que es dibuixa en l'articulaci 1, que equival al mn.
 z = A1*[0;0;0.05;1];
 y = A1*[0;0.05;0;1];
 x = A1*[0.05;0;0;1];

%Es dibuixen els eixos de cooredandes de l'articulaci 2
line([A1(1,4) z(1)],[A1(2,4) z(2)],[A1(3,4) z(3)], 'color','r','LineWidth',1);
line([A1(1,4) x(1)],[A1(2,4) x(2)],[A1(3,4) x(3)], 'color','b','LineWidth',1);
line([A1(1,4) y(1)],[A1(2,4) y(2)],[A1(3,4) y(3)], 'color','g','LineWidth',1);

%Repetim el procs per a la resta d'articulacions
line([A1(1,4);A12(1,4)],[A1(2,4);A12(2,4)],[A1(3,4);A12(3,4)],'color','c','LineWidth',2);
%Es calcula l'estat dels eixos de l'articulaci 3
z = A12*[0;0;0.05;1];
y = A12*[0;0.05;0;1];
x = A12*[0.05;0;0;1];
%Es dibuixen els eixos de cooredandes de l'articulaci 3
line([A12(1,4) z(1)],[A12(2,4) z(2)],[A12(3,4) z(3)], 'color','r','LineWidth',1);
line([A12(1,4) x(1)],[A12(2,4) x(2)],[A12(3,4) x(3)], 'color','b','LineWidth',1);
line([A12(1,4) y(1)],[A12(2,4) y(2)],[A12(3,4) y(3)], 'color','g','LineWidth',1);

%Articulaci 3
line([A12(1,4);A13(1,4)],[A12(2,4);A13(2,4)],[A12(3,4);A13(3,4)],'color','c','LineWidth',2);
%Es calcula l'estat dels eixos de l'articulaci 4
z = A13*[0;0;0.05;1];
y = A13*[0;0.05;0;1];
x = A13*[0.05;0;0;1];
%Es dibuixen els eixos de cooredandes de l'articulaci 4
line([A13(1,4) z(1)],[A13(2,4) z(2)],[A13(3,4) z(3)], 'color','r','LineWidth',1);
line([A13(1,4) x(1)],[A13(2,4) x(2)],[A13(3,4) x(3)], 'color','b','LineWidth',1);
line([A13(1,4) y(1)],[A13(2,4) y(2)],[A13(3,4) y(3)], 'color','g','LineWidth',1);

%Repetim per la articulacio 4
line([A13(1,4);A14(1,4)],[A13(2,4);A14(2,4)],[A13(3,4);A14(3,4)],'color','c','LineWidth',2);
%Es calculen els eixos de l'articulaci 5
 z = A14*[0;0;0.05;1];
 y = A14*[0;0.05;0;1];
 x = A14*[0.05;0;0;1];
%Es dibueixen els eixos de coordenades de l'articulaci 5
line([A14(1,4) z(1)],[A14(2,4) z(2)],[A14(3,4) z(3)], 'color','r','LineWidth',1);
line([A14(1,4) x(1)],[A14(2,4) x(2)],[A14(3,4) x(3)], 'color','b','LineWidth',1);
line([A14(1,4) y(1)],[A14(2,4) y(2)],[A14(3,4) y(3)], 'color','g','LineWidth',1);

%Repetim per la articulacio 5
line([A14(1,4);A15(1,4)],[A14(2,4);A15(2,4)],[A14(3,4);A15(3,4)],'color','c','LineWidth',2);
%Es calculen els eixos de l'articulaci 5
 z = A15*[0;0;0.05;1];
 y = A15*[0;0.05;0;1];
 x = A15*[0.05;0;0;1];
%Es dibueixen els eixos de coordenades de l'articulaci 5
line([A15(1,4) z(1)],[A15(2,4) z(2)],[A15(3,4) z(3)], 'color','r','LineWidth',1);
line([A15(1,4) x(1)],[A15(2,4) x(2)],[A15(3,4) x(3)], 'color','b','LineWidth',1);
line([A15(1,4) y(1)],[A15(2,4) y(2)],[A15(3,4) y(3)], 'color','g','LineWidth',1);
