%Amb aquesta funci es dibuixar el submar representant-lo com una caixa
function DibuixaSubmari(posicio)

%es defineix l'amplada, alada i longitud del robot
amp=0.4;
al=0.2;
lon=0.6;

%Es defineixen les coordenades de cada un dels vrtex
%Coordenada X
x1=lon/2;
x2=-lon/2;
x3=-lon/2;
x4=lon/2;
x5=lon/2;
x6=-lon/2;
x7=-lon/2;
x8=lon/2;
%Coordenada Y
y1=-amp/2;
y2=-amp/2;
y3=amp/2;
y4=amp/2;
y5=-amp/2;
y6=-amp/2;
y7=amp/2;
y8=amp/2;
%Coordenada Z
z1=al/2;
z2=al/2;
z3=al/2;
z4=al/2;
z5=-al/2;
z6=-al/2;
z7=-al/2;
z8=-al/2;

%Es defineixen els 8 vrtex del rectngle
v10=[x1;y1;z1];
v20=[x2;y2;z2];
v30=[x3;y3;z3];
v40=[x4;y4;z4];
v50=[x5;y5;z5];
v60=[x6;y6;z6];
v70=[x7;y7;z7];
v80=[x8;y8;z8];

%-------------------------------------------------------------------------

%Es defineixen les matrius de rotaci per representar el gir del robot
%S'obtenen els angles respecte l'entrada
phi=posicio(4);
theta=posicio(5);
psi=posicio(6);

xact=posicio(1);
yact=posicio(2);
zact=posicio(3);
actual=[xact;yact;zact];

%Rotaci respecte X angle phi
RotX=[1,0,0;0,cos(phi),-sin(phi);0,sin(phi),cos(phi)];
%Rotaci respecte Y angle theta
RotY=[cos(theta),0,sin(theta);0,1,0;-sin(theta),0,cos(theta)];
%Rotaci respecte Z angle psi
RotZ=[cos(psi),-sin(psi),0;sin(psi),cos(psi),0;0,0,1];
%Rotacio total, per ordre X, Y i Z s
Rot=RotX*RotY*RotZ;

%Es calcula la posici si noms s'hagus fet el gir per a cada un dels
%vrtexs
v1f=Rot*v10;
v2f=Rot*v20;
v3f=Rot*v30;
v4f=Rot*v40;
v5f=Rot*v50;
v6f=Rot*v60;
v7f=Rot*v70;
v8f=Rot*v80;


%Es defineix l'espai per a on es mour el submar
clf(figure(2));
axis([-5 5 -5 5 -5 5])
%axis([-1.5 1.5 -1.5 1.5 -1.5 1.5])
%axis([(xact-2) (xact+2) (yact-2) (yact+2) (zact-2) (zact+2)])

%Passem al procs de Dibuixar cada vrtex com est collocat en la realitat
%Es dibuixa el Rectangle Inferior
%Vrtex1-Vrtex2
line([v1f(1)+xact;v2f(1)+xact],[v1f(2)+yact;v2f(2)+yact],[v1f(3)+zact;v2f(3)+zact],'color','c','LineWidth',2);
%Vrtex2-Vrtex3
line([v2f(1)+xact;v3f(1)+xact],[v2f(2)+yact;v3f(2)+yact],[v2f(3)+zact;v3f(3)+zact],'color','c','LineWidth',2);
%Vrtex3-Vrtex4
line([v3f(1)+xact;v4f(1)+xact],[v3f(2)+yact;v4f(2)+yact],[v3f(3)+zact;v4f(3)+zact],'color','c','LineWidth',2);
%Vrtex4-Vrtex1
line([v4f(1)+xact;v1f(1)+xact],[v4f(2)+yact;v1f(2)+yact],[v4f(3)+zact;v1f(3)+zact],'color','c','LineWidth',2);

%Es dibuixa el rectangle superior
%Vrtex5-Vrtex6
line([v5f(1)+xact;v6f(1)+xact],[v5f(2)+yact;v6f(2)+yact],[v5f(3)+zact;v6f(3)+zact],'color','c','LineWidth',2);
%Vrtex6-Vrtex7
line([v6f(1)+xact;v7f(1)+xact],[v6f(2)+yact;v7f(2)+yact],[v6f(3)+zact;v7f(3)+zact],'color','c','LineWidth',2);
%Vrtex7-Vrtex8
line([v7f(1)+xact;v8f(1)+xact],[v7f(2)+yact;v8f(2)+yact],[v7f(3)+zact;v8f(3)+zact],'color','c','LineWidth',2);
%Vrtex8-Vrtex5
line([v8f(1)+xact;v5f(1)+xact],[v8f(2)+yact;v5f(2)+yact],[v8f(3)+zact;v5f(3)+zact],'color','c','LineWidth',2);

%Es dibuixen les lnies verticals que uneixen els dos rectangles
%Vrtex1-Vrtex2
line([v1f(1)+xact;v5f(1)+xact],[v1f(2)+yact;v5f(2)+yact],[v1f(3)+zact;v5f(3)+zact],'color','c','LineWidth',2);
%Vrtex2-Vrtex3
line([v2f(1)+xact;v6f(1)+xact],[v2f(2)+yact;v6f(2)+yact],[v2f(3)+zact;v6f(3)+zact],'color','c','LineWidth',2);
%Vrtex3-Vrtex4
line([v3f(1)+xact;v7f(1)+xact],[v3f(2)+yact;v7f(2)+yact],[v3f(3)+zact;v7f(3)+zact],'color','c','LineWidth',2);
%Vrtex4-Vrtex1
line([v4f(1)+xact;v8f(1)+xact],[v4f(2)+yact;v8f(2)+yact],[v4f(3)+zact;v8f(3)+zact],'color','c','LineWidth',2);

%Es dibuixen els eixos del submar
 z = Rot*([0;0;0.1]);
 y = Rot*([0;0.1;0]);
 x = Rot*([0.1;0;0]);
%Es dibueixen els eixos de coordenades de l'articulaci 5
%Hem canviat el signe de l'ltim membre per qu volem el positiu cap avall
line([xact (xact+z(1))],[yact (yact+z(2))],[zact (zact-z(3))], 'color','r','LineWidth',1);
line([xact (xact+x(1))],[yact (yact+x(2))],[zact (zact-x(3))], 'color','b','LineWidth',1);
line([xact (xact+y(1))],[yact (yact+y(2))],[zact (zact-y(3))], 'color','g','LineWidth',1);



