%Dinmica del submar
function accel=submari(posicio,ForcesMotors,velocitats);
%Definim les matrius que afecten en el submar
%Parmetres del submar
%Parmmetres estrictmanet fsics del submar
%Flotabilitat i centre de flotabilitat
B=30*9.81;
xb=0;
yb=0;
zb=0;

%Pes i centre de gravetat
g=9.81;
m=30;
W=m*g;
xg=0;
yg=0;
zg=0;
xc=0;
yc=0;
zc=0;

%Inrcies del submar
Ix=150;
Iy=150;
Iz=150;
Ixy=2;
Ixz=2;
Iyz=2;
Iyx=Ixy;
Izx=Ixz;
Izy=Iyz;

%Coeficients de fricci del submar
Xu=1;
Xuu=10;
Yv=1;
Yvv=10;
Zw=1;
Zww=10;
Kp=1;
Kpp=10;
Mq=1;
Mqq=10;
Nr=1;
Nrr=10;

%Masses afegides en el submar
Xudot=2;
Yvdot=2;
Zwdot=2;
Kpdot=2;
Mqdot=2;
Nrdot=2;

%Variables per facilitar el clcul
zero=zeros(3);
%--------------------------------------------------------------------------
%Angles de rotaci respecte la referncia absoluta al centre de gravetat
%del vehicle
theta=Rg(4);
cthe=cos(theta);
sthe=sin(theta);
phi=Rg(5);
cphi=cos(phi);
sphi=sin(phi);

%Es defineix la velocitat en cada un dels graus de llibertat
%Vg=[u;v;w;p;q;r];
Vg=velocitats;
vlEG=Vg(1:3);
vaEG=Vg(4:6);

%Matriu de forces en els motors, aquesta fora depn de la velocitat
%angular dels motors
X=ForcesMotors(1);
Y=ForcesMotors(2);
%Es canvia el signe del Z per qu volem que el positiu sigui cap a baix
Z=-ForcesMotors(3);
K=ForcesMotors(4);
M=ForcesMotors(5);
N=ForcesMotors(6);

%Si es considera noms la fora s
Fmotors=[X;Y;Z;K;M;N];

%Definim les forces de flotabilitat del submar
Fflot=[B*sthe;  -cthe*sphi*B;   -cthe*cphi*B;   -yb*cthe*cphi*B+zb*cthe*sphi*B;    zb*sthe*B+xb*cthe*cphi*B;   -xb*cthe*sphi*B-yb*sthe*B];

%Definim les forces degudes a la gravetat
Fgrav=[-sthe*W; cthe*sphi*W;    cthe*cphi*W;    yc*cthe*cphi*W-zc*cthe*sphi*W;  -zc*sthe*W-xc*cthe*cphi*W;  xc*cthe*sphi*W+yc*sthe*W];

%Es defineix G(O) com a la suma de Fflot i Fgrav, s'anomenar GO
GO=Fflot+Fgrav;

%Es defineix la matriu de coeficients de fricci linials i quadrtics
DVg=diag([Xu+Xuu*abs(Vg(1));Yv+Yvv*abs(Vg(2));Zw+Zww*abs(Vg(3));Kp+Kpp*abs(Vg(4));Mq+Mqq*abs(Vg(5));Nr+Nrr*abs(Vg(6))]);

%Es defineix la matriu de caracterstiques fsiques del vehicle anomenada
%gMrb
gMrb=[m,0,0,0,m*zg,-m*yg;    0,m,0,-m*zg,0,m*xg;    0,0,m,m*yg,-m*xg,0;    0,-m*zg,m*yg,Ix,-Ixy,-Ixz;    m*zg,0,-m*xg,-Iyx,Iy,-Iyz;    -m*yg,m*xg,0,-Izx,-Izy,Iz];

%Es calcula la matriu de massa afegida anomenada Ma
Ma=diag([-Xudot;-Yvdot;-Zwdot;-Kpdot;-Mqdot;-Nrdot]);

%Es defineixen unes submatrius de gMrb i de Ma per a poder calcular els
%components de les matrius de coriolis.

%submatrius de gMrb
M11=gMrb(1:3,1:3);
M12=gMrb(1:3,4:6);
M21=gMrb(4:6,1:3);
M22=gMrb(4:6,4:6);

%Submatrius de Ma
A11=Ma(1:3,1:3);
A12=Ma(1:3,4:6);
A21=Ma(4:6,1:3);
A22=Ma(4:6,4:6);

%Es calculen les matrius resultants d'utilitzar l'operador S, anomenat Smat

%Matrius per a formar Crb
Crb12=-Smat(M11*vlEG+M12*vaEG);
Crb21=Crb12;
Crb22=-Smat(M21*vlEG+M22*vaEG);

%Matrius per a formar Ca
Ca12=-Smat(A11*vlEG+A12*vaEG);
Ca21=Ca12;
Ca22=-Smat(A21*vlEG+A22*vaEG);

%Es defineix la matriu GcRB(cV) anomenada Crb
Crb=[zero,Crb12;Crb21,Crb22];
Crb
%Es defineix la matriu Ca(gV) anomenada Ca
Ca=[zero,Ca12;Ca21,Ca22];
Ca
%La equaci de Fossen s la definida
%T+GO-DVg*Vg+Pe=(gMrb+Ma)*Vg_dot+(Crb+Ca)*Vg, es suposa Pe=0 ja que sn
%perturbacions marines i sn inparamatritzables.

%Allem l'acceleraci del vehicle que s Vg_dot i obtenim la equaci
%segent: Vg_dot=(gMrb+Ma)^(-1)*(Fmotors+GO-DVg*Vg-(Crb+Ca)*Vg)
Vg_dot=(gMrb+Ma)^(-1)*(Fmotors+GO-DVg*Vg-(Crb+Ca)*Vg);
accel=Vg_dot;
end