%-----------------------
%Calcular el centre de gravetat del vehicle en funci de la posici del
%bra.
%Els parmetres necessris per a aquest clcul sn la posici angular de
%cada articulaci, la fora externa (les variables X, Y i Z, ja que
%augmenten la "massa" de l'extrem del bra) i els parmetres del bra com
%del submar.

%Parmetres
%--------------------------------------------------------------------------
Q=[10,20,30,90,50];

%Gravetat
g=9.81;
%Massa submar, manipulable desde interfcie grfica
mSub=300;

%Dimensions Submar, manipulable desde interfcie grfica
lon=1;
al=0.5;
amp=0.75;

%Inrcia submar aproximada per la hipotesis de que s un paralleppet.
ISub=mSub*[[(al^2+amp^2)/12,0,0];[0,(al^2+lon^2)/12,0];[0,0,(amp^2+lon^2)/12]];
ISub=ISub*g;

InerciaGlobal=[];
%Posici del bra en el robot, respecte el sistema de referncia del robot
XArm=[lon/2;0;al/2];

%Massa links bra, aquestes masses han de ser modificables respecte la
%interfcie grfica.
nArticulacions=5;
mArm=g*[5,3,2,0,1];

%Longitud dels links, han de ser modificables respecte la interfcie
%grfica.
lArm=[[0.05;0;0.05],[0.20;0;0],[0.15;0;0],[0;0;0],[0;0;0.02]];

%Fi parmetres
%--------------------------------------------------------------------------
%Entrada
Xcdg=0.1;
Ycdg=0.3;
Zcdg=0.05;
CDG=[Xcdg;Ycdg;Zcdg];

%Calculem les matrius i-1Ai que es calculen a la funci directaQ
%-------------------------

Q=pi/180*Q;
%Denavit hartenberg
%Parametres

Theta=[Q(1),Q(2),Q(3),Q(4),Q(5)];
Adist=[0.05,0.2,0.1,0,0];
Ddist=[0.05,0,0,0,0.02];
Alfa=([90*pi/180,0,0,90/180*pi,0]);
Home=pi/180*([0,0,90*pi/180,0,-90*pi/180]);
%Theta,d,a,alfa,home

DoF1=[Theta(1),Ddist(1),Adist(1),Alfa(1),Home(1)];
DoF2=[Theta(2),Ddist(2),Adist(2),Alfa(2),Home(2)];
DoF3=[Theta(3),Ddist(3),Adist(3),Alfa(3),Home(3)];
DoF4=[Theta(4),Ddist(4),Adist(4),Alfa(4),Home(4)];
DoF5=[Theta(5),Ddist(5),Adist(5),Alfa(5),Home(5)];


%Matrius (i-1)A(i)
A1=[cos(Theta(1)),-cos(DoF1(4))*sin(Theta(1)), sin(DoF1(4))*sin(Theta(1)),DoF1(3)*cos(Theta(1)); sin(Theta(1)), cos(DoF1(4))*cos(Theta(1)), -sin(DoF1(4))*cos(Theta(1)),DoF1(3)*sin(Theta(1));0, sin(DoF1(4)),cos(DoF1(4)),DoF1(2);0,0,0,1];
A2=[cos(Theta(2)),-cos(DoF2(4))*sin(Theta(2)), sin(DoF2(4))*sin(Theta(2)),DoF2(3)*cos(Theta(2)); sin(Theta(2)), cos(DoF2(4))*cos(Theta(2)), -sin(DoF2(4))*cos(Theta(2)),DoF2(3)*sin(Theta(2));0, sin(DoF2(4)),cos(DoF2(4)),DoF2(2);0,0,0,1];
A3=[cos(Theta(3)),-cos(DoF3(4))*sin(Theta(3)), sin(DoF3(4))*sin(Theta(3)),DoF3(3)*cos(Theta(3)); sin(Theta(3)), cos(DoF3(4))*cos(Theta(3)), -sin(DoF3(4))*cos(Theta(3)),DoF3(3)*sin(Theta(3));0, sin(DoF3(4)),cos(DoF3(4)),DoF3(2);0,0,0,1];
A4=[cos(Theta(4)),-cos(DoF4(4))*sin(Theta(4)), sin(DoF4(4))*sin(Theta(4)),DoF4(3)*cos(Theta(4)); sin(Theta(4)), cos(DoF4(4))*cos(Theta(4)), -sin(DoF4(4))*cos(Theta(4)),DoF4(3)*sin(Theta(4));0, sin(DoF4(4)),cos(DoF4(4)),DoF4(2);0,0,0,1];
A5=[cos(Theta(5)),-cos(DoF5(4))*sin(Theta(5)), sin(DoF5(4))*sin(Theta(5)),DoF5(3)*cos(Theta(5)); sin(Theta(5)), cos(DoF5(4))*cos(Theta(5)), -sin(DoF5(4))*cos(Theta(5)),DoF5(3)*sin(Theta(5));0, sin(DoF5(4)),cos(DoF5(4)),DoF5(2);0,0,0,1];

%Matrius de transformaci
A01=A1;
A02=A01*A2;
A03=A02*A3;
A04=A03*A4;
A05=A04*A5;

%Matrius de rotaci
R01=A01(1:3,1:3);
R02=A02(1:3,1:3);
R03=A03(1:3,1:3);
R04=A04(1:3,1:3);
R05=A05(1:3,1:3);
%--------------------------


%A partir de les matrius anterior s'obt la posici de cada element
%terminal respecte la base del mateix bra
Base_=XArm;
Art1_=A01(1:3,4);
Art2_=A02(1:3,4);
Art3_=A03(1:3,4);
Art4_=A04(1:3,4);
Art5_=A05(1:3,4);

%Es calcula la posici del centre de gravetat de tot el bra suposant que
%cada element te el seu centre de masses al mig de la longitud del link
CdG1_=Base_+R01*lArm(:,1);
CdG2_=Art1_+R02*lArm(:,2);
CdG3_=Art2_+R03*lArm(:,3);
CdG4_=Art3_+R04*lArm(:,4);
CdG5_=Art4_+R05*lArm(:,5);

%Clcul de la distncia del centre de gravetat de cada element del bra
%respecte al centre de gravetat actual del robot.
D=[CdG1_, CdG2_, CdG3_, CdG4_, CdG5_];

InerciaGlobal=ISub;
for i=1:nArticulacions
    
    x=D(1,i);
    y=D(2,i);
    z=D(3,i);
    
    Inerciai=mArm(i)*[[z^2+y^2,-x*y,-x*z];[-y*x,x^2+z^2,-y*z];[-z*x,-z*y,x^2+y^2]];
    InerciaGlobal=InerciaGlobal+Inerciai;
    
end

InerciaGlobal=1/g*InerciaGlobal;
    

%Sortida "CDGglobal"
%-----------------------