%PlotAll s una funci que pintar el submar i el bra mecnic tot junt,
%per aix ens caldr tan parmetres d'entrada del submar com del bra
%mecnic

%L'entrada ser els angles i la posici del submar

function PlotAll(entrada)

%--------------------------------------------------------------------------
%Parmetres per al dibuix del submar
%--------------------------------------------------------------------------
%es defineix l'amplada, alada i longitud del robot
%[x,y,z,ox,oy,oz,q1,q2,q3,q4,q5,l1,l2,l3,l4,l5,lon,amp,al];
xact=entrada(1);
yact=entrada(2);
zact=entrada(3);
phi=entrada(4);
theta=entrada(5);
psi=entrada(6);
actual=[xact;yact;zact];
Q=entrada(7:11);
l1=entrada(12);
l2=entrada(13);
l3=entrada(14);
l4=entrada(15);
l5=entrada(16);
lon=entrada(17);
al=entrada(18);
amp=entrada(19);

%Es defineixen les matrius de rotaci per representar el gir del robot
%S'obtenen els angles respecte l'entrada


%Es defineixen les coordenades de cada un dels vrtex
%Coordenada X
x1=lon/2;
x2=-lon/2;
x3=-lon/2;
x4=lon/2;
x5=lon/2;
x6=-lon/2;
x7=-lon/2;
x8=lon/2;
%Coordenada Y
y1=-amp/2;
y2=-amp/2;
y3=amp/2;
y4=amp/2;
y5=-amp/2;
y6=-amp/2;
y7=amp/2;
y8=amp/2;
%Coordenada Z
z1=al/2;
z2=al/2;
z3=al/2;
z4=al/2;
z5=-al/2;
z6=-al/2;
z7=-al/2;
z8=-al/2;

%Es defineixen els 8 vrtex del rectngle
v10=[x1;y1;z1];
v20=[x2;y2;z2];
v30=[x3;y3;z3];
v40=[x4;y4;z4];
v50=[x5;y5;z5];
v60=[x6;y6;z6];
v70=[x7;y7;z7];
v80=[x8;y8;z8];

%Rotaci respecte X angle phi
RotX=[1,0,0;0,cos(phi),-sin(phi);0,sin(phi),cos(phi)];
%Rotaci respecte Y angle theta
RotY=[cos(theta),0,sin(theta);0,1,0;-sin(theta),0,cos(theta)];
%Rotaci respecte Z angle psi
RotZ=[cos(psi),-sin(psi),0;sin(psi),cos(psi),0;0,0,1];
%Rotacio total, per ordre X, Y i Z s
Rot=RotX*RotY*RotZ;

%--------------------------------------------------------------------------
%Parmetres per al dibuix del bra
%--------------------------------------------------------------------------
%Posici de la base
XArm=[lon/2;0;al/2];

%es posa la orientaci que te el vehicle
XArm=Rot*XArm+actual;

%Es Defineix la matriu que representa la posici de la base del bra
%respecte el sistema de coordenades fix del robot

A00=[Rot(1,1),Rot(1,2),Rot(1,3),XArm(1);Rot(2,1),Rot(2,2),Rot(2,3),XArm(2);Rot(3,1),Rot(3,2),Rot(3,3),XArm(3);0,0,0,1];

% Apliquem Denavit Hartenberg i les matrius per saber la posici final de
% l'element, on Q(i) s'extreu de la posici actual obtinguda a partir
% d'integraci de la acceleraci i velocitat


%Denavit hartenberg
%Parametres

Theta=[Q(1),Q(2),Q(3),Q(4),Q(5)];
Adist=[l1,l3,l4,0,0];
Ddist=[l2,0,0,0,l5];
Alfa=([90*pi/180,0,0,90/180*pi,0]);
Home=pi/180*([0,0,90*pi/180,0,-90*pi/180]);
%Theta,d,a,alfa,home

DoF1=[Theta(1),Ddist(1),Adist(1),Alfa(1),Home(1)];
DoF2=[Theta(2),Ddist(2),Adist(2),Alfa(2),Home(2)];
DoF3=[Theta(3),Ddist(3),Adist(3),Alfa(3),Home(3)];
DoF4=[Theta(4),Ddist(4),Adist(4),Alfa(4),Home(4)];
DoF5=[Theta(5),Ddist(5),Adist(5),Alfa(5),Home(5)];


%Matrius (i-1)A(i)
A1=[cos(Theta(1)),-cos(DoF1(4))*sin(Theta(1)), sin(DoF1(4))*sin(Theta(1)),DoF1(3)*cos(Theta(1)); sin(Theta(1)), cos(DoF1(4))*cos(Theta(1)), -sin(DoF1(4))*cos(Theta(1)),DoF1(3)*sin(Theta(1));0, sin(DoF1(4)),cos(DoF1(4)),DoF1(2);0,0,0,1];
A2=[cos(Theta(2)),-cos(DoF2(4))*sin(Theta(2)), sin(DoF2(4))*sin(Theta(2)),DoF2(3)*cos(Theta(2)); sin(Theta(2)), cos(DoF2(4))*cos(Theta(2)), -sin(DoF2(4))*cos(Theta(2)),DoF2(3)*sin(Theta(2));0, sin(DoF2(4)),cos(DoF2(4)),DoF2(2);0,0,0,1];
A3=[cos(Theta(3)),-cos(DoF3(4))*sin(Theta(3)), sin(DoF3(4))*sin(Theta(3)),DoF3(3)*cos(Theta(3)); sin(Theta(3)), cos(DoF3(4))*cos(Theta(3)), -sin(DoF3(4))*cos(Theta(3)),DoF3(3)*sin(Theta(3));0, sin(DoF3(4)),cos(DoF3(4)),DoF3(2);0,0,0,1];
A4=[cos(Theta(4)),-cos(DoF4(4))*sin(Theta(4)), sin(DoF4(4))*sin(Theta(4)),DoF4(3)*cos(Theta(4)); sin(Theta(4)), cos(DoF4(4))*cos(Theta(4)), -sin(DoF4(4))*cos(Theta(4)),DoF4(3)*sin(Theta(4));0, sin(DoF4(4)),cos(DoF4(4)),DoF4(2);0,0,0,1];
A5=[cos(Theta(5)),-cos(DoF5(4))*sin(Theta(5)), sin(DoF5(4))*sin(Theta(5)),DoF5(3)*cos(Theta(5)); sin(Theta(5)), cos(DoF5(4))*cos(Theta(5)), -sin(DoF5(4))*cos(Theta(5)),DoF5(3)*sin(Theta(5));0, sin(DoF5(4)),cos(DoF5(4)),DoF5(2);0,0,0,1];
%Definim les matrius necessaries per a fer el PLOT.
A1=A00*A1;
A12=A1*A2;
A13=A12*A3;
A14=A13*A4;
A15=A14*A5;

%--------------------------------------------------------------------------
%Fi Parmetres
%--------------------------------------------------------------------------



%-------------------------------------------------------------------------
%Dibuixar el Submar
%-------------------------------------------------------------------------

%Es calcula la posici si noms s'hagus fet el gir per a cada un dels
%vrtexs
v1f=Rot*v10;
v2f=Rot*v20;
v3f=Rot*v30;
v4f=Rot*v40;
v5f=Rot*v50;
v6f=Rot*v60;
v7f=Rot*v70;
v8f=Rot*v80;


%Passem al procs de Dibuixar cada vrtex com est collocat en la realitat
%Es dibuixa el Rectangle Inferior
%Vrtex1-Vrtex2
line([v1f(1)+xact;v2f(1)+xact],[v1f(2)+yact;v2f(2)+yact],[v1f(3)+zact;v2f(3)+zact],'color','c','LineWidth',2);
%Vrtex2-Vrtex3
line([v2f(1)+xact;v3f(1)+xact],[v2f(2)+yact;v3f(2)+yact],[v2f(3)+zact;v3f(3)+zact],'color','c','LineWidth',2);
%Vrtex3-Vrtex4
line([v3f(1)+xact;v4f(1)+xact],[v3f(2)+yact;v4f(2)+yact],[v3f(3)+zact;v4f(3)+zact],'color','c','LineWidth',2);
%Vrtex4-Vrtex1
line([v4f(1)+xact;v1f(1)+xact],[v4f(2)+yact;v1f(2)+yact],[v4f(3)+zact;v1f(3)+zact],'color','c','LineWidth',2);

%Es dibuixa el rectangle superior
%Vrtex5-Vrtex6
line([v5f(1)+xact;v6f(1)+xact],[v5f(2)+yact;v6f(2)+yact],[v5f(3)+zact;v6f(3)+zact],'color','c','LineWidth',2);
%Vrtex6-Vrtex7
line([v6f(1)+xact;v7f(1)+xact],[v6f(2)+yact;v7f(2)+yact],[v6f(3)+zact;v7f(3)+zact],'color','c','LineWidth',2);
%Vrtex7-Vrtex8
line([v7f(1)+xact;v8f(1)+xact],[v7f(2)+yact;v8f(2)+yact],[v7f(3)+zact;v8f(3)+zact],'color','c','LineWidth',2);
%Vrtex8-Vrtex5
line([v8f(1)+xact;v5f(1)+xact],[v8f(2)+yact;v5f(2)+yact],[v8f(3)+zact;v5f(3)+zact],'color','c','LineWidth',2);

%Es dibuixen les lnies verticals que uneixen els dos rectangles
%Vrtex1-Vrtex2
line([v1f(1)+xact;v5f(1)+xact],[v1f(2)+yact;v5f(2)+yact],[v1f(3)+zact;v5f(3)+zact],'color','c','LineWidth',2);
%Vrtex2-Vrtex3
line([v2f(1)+xact;v6f(1)+xact],[v2f(2)+yact;v6f(2)+yact],[v2f(3)+zact;v6f(3)+zact],'color','c','LineWidth',2);
%Vrtex3-Vrtex4
line([v3f(1)+xact;v7f(1)+xact],[v3f(2)+yact;v7f(2)+yact],[v3f(3)+zact;v7f(3)+zact],'color','c','LineWidth',2);
%Vrtex4-Vrtex1
line([v4f(1)+xact;v8f(1)+xact],[v4f(2)+yact;v8f(2)+yact],[v4f(3)+zact;v8f(3)+zact],'color','c','LineWidth',2);

%Es dibuixen els eixos del submar
%z = A00(1:3,1:3)*([0;0;0.1]);
%y = A00(1:3,1:3)*([0;0.1;0]);
%x = A00(1:3,1:3)*([0.1;0;0]);
%Es dibueixen els eixos de coordenades de l'articulaci 5
%Hem canviat el signe de l'ltim membre per qu volem el positiu cap avall
%line([xact (xact+z(1))],[yact (yact+z(2))],[zact (zact-z(3))], 'color','r','LineWidth',1);
%line([xact (xact+x(1))],[yact (yact+x(2))],[zact (zact-x(3))], 'color','b','LineWidth',1);
%line([xact (xact+y(1))],[yact (yact+y(2))],[zact (zact-y(3))], 'color','g','LineWidth',1);

%--------------------------------------------------------------------------
%--------------------------------------------------------------------------

%Dibuixem primer el link i llavors els eixox de referncia
line([XArm(1);A1(1,4)],[XArm(2);A1(2,4)],[XArm(3);A1(3,4)],'color','c','LineWidth',2);
%Es dibuixen els eixos de coordenades de la articulaci 1, que coincideix amb
%els del mn i que sempre sn fixes. Sn els eixos de referncia
%Es dibuixa l'eix z
line([0 0],[0 0],[0 0.05], 'color','r','LineWidth',1);
%Es dibuixa l'eix x
line([0 0.05],[0 0],[0 0], 'color','b','LineWidth',1);
%Es dibuixa l'eix y
line([0 0],[0 0.05],[0 0], 'color','g','LineWidth',1);
%Es calcula l'estat dels eixos de l'articulaci 2, per tant cal
%multiplicar la matriu que relaciona l'eix de coordeandes de l'articulacio
%2 amb l'eix de cooredenades del mn, per el punt on acabava cada eix de
%coordenades que es dibuixa en l'articulaci 1, que equival al mn.
 z = A1*[0;0;0.05;1];
 y = A1*[0;0.05;0;1];
 x = A1*[0.05;0;0;1];

%Es dibuixen els eixos de cooredandes de l'articulaci 2
line([A1(1,4) z(1)],[A1(2,4) z(2)],[A1(3,4) z(3)], 'color','r','LineWidth',1);
line([A1(1,4) x(1)],[A1(2,4) x(2)],[A1(3,4) x(3)], 'color','b','LineWidth',1);
line([A1(1,4) y(1)],[A1(2,4) y(2)],[A1(3,4) y(3)], 'color','g','LineWidth',1);

%Repetim el procs per a la resta d'articulacions
line([A1(1,4);A12(1,4)],[A1(2,4);A12(2,4)],[A1(3,4);A12(3,4)],'color','c','LineWidth',2);
%Es calcula l'estat dels eixos de l'articulaci 3
z = A12*[0;0;0.05;1];
y = A12*[0;0.05;0;1];
x = A12*[0.05;0;0;1];
%Es dibuixen els eixos de cooredandes de l'articulaci 3
line([A12(1,4) z(1)],[A12(2,4) z(2)],[A12(3,4) z(3)], 'color','r','LineWidth',1);
line([A12(1,4) x(1)],[A12(2,4) x(2)],[A12(3,4) x(3)], 'color','b','LineWidth',1);
line([A12(1,4) y(1)],[A12(2,4) y(2)],[A12(3,4) y(3)], 'color','g','LineWidth',1);

%Articulaci 3
line([A12(1,4);A13(1,4)],[A12(2,4);A13(2,4)],[A12(3,4);A13(3,4)],'color','c','LineWidth',2);
%Es calcula l'estat dels eixos de l'articulaci 4
z = A13*[0;0;0.05;1];
y = A13*[0;0.05;0;1];
x = A13*[0.05;0;0;1];
%Es dibuixen els eixos de cooredandes de l'articulaci 4
line([A13(1,4) z(1)],[A13(2,4) z(2)],[A13(3,4) z(3)], 'color','r','LineWidth',1);
line([A13(1,4) x(1)],[A13(2,4) x(2)],[A13(3,4) x(3)], 'color','b','LineWidth',1);
line([A13(1,4) y(1)],[A13(2,4) y(2)],[A13(3,4) y(3)], 'color','g','LineWidth',1);

%Repetim per la articulacio 4
line([A13(1,4);A14(1,4)],[A13(2,4);A14(2,4)],[A13(3,4);A14(3,4)],'color','c','LineWidth',2);
%Es calculen els eixos de l'articulaci 5
 z = A14*[0;0;0.05;1];
 y = A14*[0;0.05;0;1];
 x = A14*[0.05;0;0;1];
%Es dibueixen els eixos de coordenades de l'articulaci 5
line([A14(1,4) z(1)],[A14(2,4) z(2)],[A14(3,4) z(3)], 'color','r','LineWidth',1);
line([A14(1,4) x(1)],[A14(2,4) x(2)],[A14(3,4) x(3)], 'color','b','LineWidth',1);
line([A14(1,4) y(1)],[A14(2,4) y(2)],[A14(3,4) y(3)], 'color','g','LineWidth',1);

%Repetim per la articulacio 5
line([A14(1,4);A15(1,4)],[A14(2,4);A15(2,4)],[A14(3,4);A15(3,4)],'color','c','LineWidth',2);
%Es calculen els eixos de l'articulaci 5
 z = A15*[0;0;0.05;1];
 y = A15*[0;0.05;0;1];
 x = A15*[0.05;0;0;1];
%Es dibueixen els eixos de coordenades de l'articulaci 5
line([A15(1,4) z(1)],[A15(2,4) z(2)],[A15(3,4) z(3)], 'color','r','LineWidth',1);
line([A15(1,4) x(1)],[A15(2,4) x(2)],[A15(3,4) x(3)], 'color','b','LineWidth',1);
line([A15(1,4) y(1)],[A15(2,4) y(2)],[A15(3,4) y(3)], 'color','g','LineWidth',1);

%-------------------------------------------------------------------------
%-------------------------------------------------------------------------
end
