%control del procs

function output=control(Pactual,Pobject,Vanterior,Error_anterior,Fanterior,SampleTime);

vel=[];
vcons=[];
FMot=[];
FMot_=[];
ErrorPos=[];

ErrorPos=Pobject-Pactual;

VFMax=30;
ErrorMax=0.001;

Fanterior=-Fanterior;
Ts=SampleTime;
%VMax=[0.4,0.3,0.2,0.2,0.2,2];
VMax=[0.45,0.3,0.4,0.2,0.2,1.1];
KVel=[3,3,2,1,50,10];
FMax=[50,50,50,50,50,50];

%Parmetres del PID ERROR POSITIU
Kp_pos=[-4500,      -3000,      -3500,      -5,      -98,      -50];
Ki_pos=[0,      0,      100,     0,      5,      0];
Kd_pos=[0,      0,      0,      0,      0,      0];
%Parmetres del PID ERROR NEGATIU
Kp_neg=[-4500,      -3000,      -4500,      -5,      -98,      -50];
Ki_neg=[0,          0,     100,      0,      5,     0];
Kd_neg=[0,          0,      0,      0,      0,      0];


%Angles de rotaci respecte la referncia absoluta al centre de gravetat
%del vehicle, PHI=4, THETA=5, PSI=6
theta=Pactual(5);
cthe=cos(theta);
sthe=sin(theta);
tthe=tan(theta);
phi=Pactual(4);
cphi=cos(phi);
sphi=sin(phi);
psi=Pactual(6);
cpsi=cos(psi);
spsi=sin(psi);

%Matriu de rotaci de coordenades absolutes a relatives
matEG=[[cpsi*cthe,  -spsi*cphi+cpsi*sphi*sthe,  cphi*cpsi*sthe+sphi*spsi,   0,      0,          0];
    [spsi*cthe,     cpsi*cphi+spsi*sphi*sthe,  -sphi*cpsi+cphi*spsi*sthe,   0,      0,          0];
    [-sthe,          sphi*cthe,                cphi*cthe,                  0,      0,          0];
    [0,             0,                          0,                          1,      sphi*tthe,  cphi*tthe];
    [0,             0,                          0,                          0,      cphi,       -sphi];
    [0,             0,                          0,                          0,      sphi/cthe,cphi/cthe]];

%Es Calcula la velocitat que hauria de tenir en funci de la distncia,
for i=1:6
    veli=KVel(i)*ErrorPos(i);
    vel=[vel veli];
end

%Passem de l'error en velocitat de terra a error en velocitat del vehicle
vel1=matEG(1:3,1:3)^-1*vel(1:3)';
vel2=matEG(4:6,4:6)^-1*vel(4:6)';
vel3=[vel1;vel2];

%Un cop calculada la velocitat que hauria de tenir en funci de l'error es
%es limita aquesta velocitat a la que solen tenir com a mxima aquesta mena
%de submarins


for i=1:6
    if (abs(vel3(i)))>VMax(i)
        vel3(i)=sign(vel3(i))*VMax(i);
    elseif (abs(vel3(i)))<VMax(i)
        vel3(i)=vel3(i);
    end
    vcons=[vcons vel3(i)];
end

%Error=vcons-[matEG(1:3,1:3)^-1*Vanterior(1:3);matEG(4:6,4:6)^-1*Vanterior(4:6)];
vant=[matEG(1:3,1:3)^-1*Vanterior(1:3);matEG(4:6,4:6)^-1*Vanterior(4:6)];
Error=vcons'-vant;

Eintegral=Error_anterior+Error*Ts;
Ederivatiu=(Error-Error_anterior)/Ts;

for i=1:6
    if Error(i)<=0;
        FNi=Kp_neg(i)*Error(i)+Kd_neg(i)*Ederivatiu(i)+Ki_neg(i)*Eintegral(i);
    elseif Error(i)>0;
        FNi=Kp_pos(i)*Error(i)+Kd_pos(i)*Ederivatiu(i)+Ki_pos(i)*Eintegral(i);
    end
    FMot_=[FMot_ FNi];
end

%Es limita la potncia del motor.
for i=1:6
    if abs(FMot_(i))>FMax(i)
        FMoti=sign(FMot_(i))*FMax(i);
    elseif abs(FMot_(i))<FMax(i)
        FMoti=FMot_(i);
    end
FMot=[FMot FMoti];
end

for i=1:6
    if abs(FMot(i)-Fanterior(i))>VFMax
        FMot(i)=Fanterior(i)+sign(FMot(i))*VFMax;
    elseif abs(FMot(i)-Fanterior(i))<VFMax
        FMot(i)=FMot(i);
    end

end

%Es limita la potncia del motor.
for i=1:6
    if abs(FMot(i))>FMax(i)
        FMot(i)=sign(FMot(i))*FMax(i);
    elseif abs(FMot(i))<FMax(i)
        FMot(i)=FMot(i);
    end

end

output=[-FMot,Error_anterior'];
end
        
        