%Funci per pintar el bra a partir de les VRML, aquesta funci el que
%agafa sn les distncies conegudes del bra amb VRML

%L'entrada s el vector posici i orientaci del submar i les Qs de la
%collocaci del bra.
function Output=funcioBRA(entrada);

%ENTRADA-----------------------------------

clf(figure(1))
cla(figure(1));
axis([-0.75,0.75,-0.75,0.75,-0.75,0.75,])
set(gca,'XDir','Reverse','ZDir','Reverse')
xact=entrada(1);
yact=entrada(2);
zact=entrada(3);
phi=entrada(4);
theta=entrada(5);
psi=entrada(6);
Q=entrada(7:10);
actual=[xact;yact;zact];

load('BRA_1.mat');
load('BRA_2.mat');
load('BRA_3.mat');
load('BRA_4.mat');
[h_bra1,Bra1] = plot_3Dobj(NaN,NaN,NaN,NaN,NaN,NaN, Bra1);
[h_bra2,Bra2] = plot_3Dobj(NaN,NaN,NaN,NaN,NaN,NaN, Bra2);
[h_bra3,Bra3] = plot_3Dobj(NaN,NaN,NaN,NaN,NaN,NaN, Bra3);
[h_bra4,Bra4] = plot_3Dobj(NaN,NaN,NaN,NaN,NaN,NaN, Bra4);
%FI ENTRADA--------------------------------



%Rotaci respecte X angle phi
RotX=[1,0,0;0,cos(phi),-sin(phi);0,sin(phi),cos(phi)];
%Rotaci respecte Y angle theta
RotY=[cos(theta),0,sin(theta);0,1,0;-sin(theta),0,cos(theta)];
%Rotaci respecte Z angle psi
RotZ=[cos(psi),-sin(psi),0;sin(psi),cos(psi),0;0,0,1];
%Rotacio total, per ordre X, Y i Z s
Rot=RotX*RotY*RotZ;

%Posici de la base
XArm=[0.28;0;0.35];
%es posa la orientaci que te el vehicle
XArm=Rot*XArm+actual;
%Es Defineix la matriu que representa la posici de la base del bra
%respecte el sistema de coordenades fix del robot
A00=[Rot(1,1),Rot(1,2),Rot(1,3),XArm(1);Rot(2,1),Rot(2,2),Rot(2,3),XArm(2);Rot(3,1),Rot(3,2),Rot(3,3),XArm(3);0,0,0,1];
% Apliquem Denavit Hartenberg i les matrius per saber la posici final de
% l'element, on Q(i) s'extreu de la posici actual obtinguda a partir
% d'integraci de la acceleraci i velocitat
%CEixos=diag([-1,1,-1]);
        
%Theta,d,a,alfa,home
Theta=[Q(1),Q(2),Q(3),90*pi/180,Q(4)];
Adist=[0.12,0.25,0.17,0,0];
Ddist=[0,0,0,0,0.1];
Alfa=([-90*pi/180,0,-90*pi/180,90/180*pi,-90*pi/180]);
Home=([0,0,90*pi/180,0,-90*pi/180]);

DoF1=[Theta(1),Ddist(1),Adist(1),Alfa(1),Home(1)];
DoF2=[Theta(2),Ddist(2),Adist(2),Alfa(2),Home(2)];
DoF3=[Theta(3),Ddist(3),Adist(3),Alfa(3),Home(3)];
DoF4=[Theta(4),Ddist(4),Adist(4),Alfa(4),Home(4)];
DoF5=[Theta(5),Ddist(5),Adist(5),Alfa(5),Home(5)];

%Matrius (i-1)A(i)
A1=[cos(Theta(1)),-cos(DoF1(4))*sin(Theta(1)), sin(DoF1(4))*sin(Theta(1)),DoF1(3)*cos(Theta(1)); sin(Theta(1)), cos(DoF1(4))*cos(Theta(1)), -sin(DoF1(4))*cos(Theta(1)),DoF1(3)*sin(Theta(1));0, sin(DoF1(4)),cos(DoF1(4)),DoF1(2);0,0,0,1];
A2=[cos(Theta(2)),-cos(DoF2(4))*sin(Theta(2)), sin(DoF2(4))*sin(Theta(2)),DoF2(3)*cos(Theta(2)); sin(Theta(2)), cos(DoF2(4))*cos(Theta(2)), -sin(DoF2(4))*cos(Theta(2)),DoF2(3)*sin(Theta(2));0, sin(DoF2(4)),cos(DoF2(4)),DoF2(2);0,0,0,1];
A3=[cos(Theta(3)),-cos(DoF3(4))*sin(Theta(3)), sin(DoF3(4))*sin(Theta(3)),DoF3(3)*cos(Theta(3)); sin(Theta(3)), cos(DoF3(4))*cos(Theta(3)), -sin(DoF3(4))*cos(Theta(3)),DoF3(3)*sin(Theta(3));0, sin(DoF3(4)),cos(DoF3(4)),DoF3(2);0,0,0,1];
A4=[cos(Theta(4)),-cos(DoF4(4))*sin(Theta(4)), sin(DoF4(4))*sin(Theta(4)),DoF4(3)*cos(Theta(4)); sin(Theta(4)), cos(DoF4(4))*cos(Theta(4)), -sin(DoF4(4))*cos(Theta(4)),DoF4(3)*sin(Theta(4));0, sin(DoF4(4)),cos(DoF4(4)),DoF4(2);0,0,0,1];
A5=[cos(Theta(5)),-cos(DoF5(4))*sin(Theta(5)), sin(DoF5(4))*sin(Theta(5)),DoF5(3)*cos(Theta(5)); sin(Theta(5)), cos(DoF5(4))*cos(Theta(5)), -sin(DoF5(4))*cos(Theta(5)),DoF5(3)*sin(Theta(5));0, sin(DoF5(4)),cos(DoF5(4)),DoF5(2);0,0,0,1];

%A00=eye(4)
%Definim les matrius necessaries per a fer el PLOT.
A1=A00*A1;
A12=A1*A2;
A13=A12*A3;
A14=A13*A4;
A15=A14*A5;

plot_3Dobj(A00(1,4), A00(2,4), A00(3,4), phi, theta, psi+Q(1), Bra1, h_bra1);
plot_3Dobj(A1(1,4), A1(2,4), A1(3,4), phi, theta+Q(2), psi+Q(1), Bra2, h_bra2);
plot_3Dobj(A12(1,4), A12(2,4), A12(3,4), phi, theta+Q(2)+Q(3), psi+Q(1), Bra3, h_bra3);
plot_3Dobj(A14(1,4), A14(2,4), A14(3,4), phi, theta+Q(2)+Q(3)+Q(4), psi+Q(1), Bra4, h_bra4);
end


