%Aquesta funci s el programa que ens donar les sortides a dibuixar del
%submar ms bra articulat havent-se calculat la dinmica del bra i del
%submar
%function programa(Pactual,Pobjectiu,mSub,midesSub,Vg,vec_inicial,vec_final,F_ext,longituds,mArm)
function sortida=programa(entrada)
%----------------------------------------------------------------------
%POSSIBLES PARMETRES
%----------------------------------------------------------------------

g=9.81;
nArticulacions=5;

%----------------------------------------------------------------------
%
%----------------------------------------------------------------------

%----------------------------------------------------------------------
%%Entrada de valors
%----------------------------------------------------------------------

Pactual=entrada(1:6)';
Rg=Pactual;
Pobjectiu=entrada(7:12)';
mSub=entrada(13);
midesSub=entrada(14:16);
Vg=entrada(17:22)';
vec_inicial=entrada(23:28);
vec_final=entrada(29:34);

F_ext=entrada(35:40)';
longituds=entrada(41:45);
mArm=[entrada(46:50)];
Fgrav=entrada(51:56);
Error_anterior=entrada(57:62)';
SampleTime=entrada(63);
Ts=SampleTime;
Fanterior=entrada(64:69);

%Es passa a variables de clcul
lon=midesSub(1);
amp=midesSub(2);
al=midesSub(3);
l1=longituds(1);
l2=longituds(2);
l3=longituds(3);
l4=longituds(4);
l5=longituds(5);

lArm=[[longituds(1);0;longituds(2)],[longituds(3);0;0],[longituds(4);0;0],[0;0;0],[0;0;longituds(5)]];

%Aquest sistema serveix per a controlar les forces del submar, per a
%poder arribar a la posici dest
control(Pactual,Pobjectiu,Vg,Error_anterior,Fanterior,SampleTime);

sort=ans;
ForcesMotors=sort(1:6);
Error_anterior=sort(7:12);


%----------------------------------------------------------------------
%INICI--CLCUL DEL BRA ARTICULAT
%----------------------------------------------------------------------
entradaTRAJ=[F_ext',vec_inicial,vec_final,longituds,mArm,SampleTime];
Traj_circ(entradaTRAJ);
FBase_pos=ans;
FBase=FBase_pos(:,1);
Identitat_=diag([1;1;1;1;1;1]);
FBase=Identitat_*FBase;

POS_bra=FBase_pos(:,2);  

%Posici del bra en el robot, respecte el sistema de referncia del robot
XArm=[lon/2,0,al/2];
%FBase=[0;0;0;0;0;0];
FCDG=FBase(1:3);
Carrega=F_ext(3);
%Posici de l'extrem s
Pextrem=vec_inicial(1:3);

%----------------------------------------------------------------------
%FI--CLCUL DEL BRA ARTICULAT
%----------------------------------------------------------------------

%----------------------------------------------------------------------
%INICI--CLCUL DEL CENTRE DE GRAVETAT DEL VEHICLE
%----------------------------------------------------------------------
%Calcular el centre de gravetat del vehicle en funci de la posici del
%bra.
%Els parmetres necessris per a aquest clcul sn la posici angular de
%cada articulaci, la fora externa (les variables X, Y i Z, ja que
%augmenten la "massa" de l'extrem del bra) i els parmetres del bra com
%del submar.

%Punt a on est collocada la massa de l'extrem



%Clcul del centre de gravetat mitjanant moments respecte la base del
%robot, punt situat a XArm=[lon/2,0,al/2];
Xcdg=(-mSub*g*XArm(1)+Pextrem(1)*Carrega)/(mSub*g+Carrega);
Ycdg=(-mSub*g*XArm(2)+Pextrem(2)*Carrega)/(mSub*g+Carrega);
Zcdg=(-mSub*g*XArm(3)+Pextrem(3)*Carrega)/(mSub*g+Carrega);

%----------------------------------------------------------------------
%FI--CLCUL DEL CENTRE DE GRAVETAT DEL VEHICLE
%----------------------------------------------------------------------

%----------------------------------------------------------------------
%INICI--CLCUL DE LA MATRIU TENSOR D'INRCIES DEL CONJUNT
%----------------------------------------------------------------------
%Inrcia submar aproximada per la hipotesis de que s un
%paralleppet, es calcular la inrcia no en kgm sino en Nm per a
%tenir en compte la crrega.

ISub=mSub*[[(al^2+amp^2)/12,0,0];[0,(al^2+lon^2)/12,0];[0,0,(amp^2+lon^2)/12]];
ISub=ISub*g;
InerciaGlobal=[];

%Fi parmetres
xact=Pactual(1);
yact=Pactual(2);
zact=Pactual(3);
%--------------------------------------------------------------------------
CDG=[lon/2+Xcdg;Ycdg;al/2+Zcdg];

%Denavit hartenberg
%Parametres
entrada=[POS_bra',longituds];
inversaVL(entrada);
Q=pi/180*ans;
Q_sortida=Q;

Theta=[Q(1),Q(2),Q(3),Q(4),Q(5)];
Adist=[l1,l3,l4,0,0];
Ddist=[l2,0,0,0,l5];
Alfa=([-90*pi/180,0,-90*pi/180,90/180*pi,-90*pi/180]);
Home=pi/180*([0,0,90*pi/180,0,-90*pi/180]);
%Theta,d,a,alfa,home

DoF1=[Theta(1),Ddist(1),Adist(1),Alfa(1),Home(1)];
DoF2=[Theta(2),Ddist(2),Adist(2),Alfa(2),Home(2)];
DoF3=[Theta(3),Ddist(3),Adist(3),Alfa(3),Home(3)];
DoF4=[Theta(4),Ddist(4),Adist(4),Alfa(4),Home(4)];
DoF5=[Theta(5),Ddist(5),Adist(5),Alfa(5),Home(5)];

%Matrius (i-1)A(i)
A1=[cos(Theta(1)),-cos(DoF1(4))*sin(Theta(1)), sin(DoF1(4))*sin(Theta(1)),DoF1(3)*cos(Theta(1)); sin(Theta(1)), cos(DoF1(4))*cos(Theta(1)), -sin(DoF1(4))*cos(Theta(1)),DoF1(3)*sin(Theta(1));0, sin(DoF1(4)),cos(DoF1(4)),DoF1(2);0,0,0,1];
A1CDG=[cos(Theta(1)),-cos(DoF1(4))*sin(Theta(1)), sin(DoF1(4))*sin(Theta(1)),0.5*DoF1(3)*cos(Theta(1)); sin(Theta(1)), cos(DoF1(4))*cos(Theta(1)), -sin(DoF1(4))*cos(Theta(1)),0.5*DoF1(3)*sin(Theta(1));0, sin(DoF1(4)),cos(DoF1(4)),0.5*DoF1(2);0,0,0,1];
A2=[cos(Theta(2)),-cos(DoF2(4))*sin(Theta(2)), sin(DoF2(4))*sin(Theta(2)),DoF2(3)*cos(Theta(2)); sin(Theta(2)), cos(DoF2(4))*cos(Theta(2)), -sin(DoF2(4))*cos(Theta(2)),DoF2(3)*sin(Theta(2));0, sin(DoF2(4)),cos(DoF2(4)),DoF2(2);0,0,0,1];
A2CDG=[cos(Theta(2)),-cos(DoF2(4))*sin(Theta(2)), sin(DoF2(4))*sin(Theta(2)),0.5*DoF2(3)*cos(Theta(2)); sin(Theta(2)), cos(DoF2(4))*cos(Theta(2)), -sin(DoF2(4))*cos(Theta(2)),0.5*DoF2(3)*sin(Theta(2));0, sin(DoF2(4)),cos(DoF2(4)),0.5*DoF2(2);0,0,0,1];
A3=[cos(Theta(3)),-cos(DoF3(4))*sin(Theta(3)), sin(DoF3(4))*sin(Theta(3)),DoF3(3)*cos(Theta(3)); sin(Theta(3)), cos(DoF3(4))*cos(Theta(3)), -sin(DoF3(4))*cos(Theta(3)),DoF3(3)*sin(Theta(3));0, sin(DoF3(4)),cos(DoF3(4)),DoF3(2);0,0,0,1];
A3CDG=[cos(Theta(3)),-cos(DoF3(4))*sin(Theta(3)), sin(DoF3(4))*sin(Theta(3)),0.5*DoF3(3)*cos(Theta(3)); sin(Theta(3)), cos(DoF3(4))*cos(Theta(3)), -sin(DoF3(4))*cos(Theta(3)),0.5*DoF3(3)*sin(Theta(3));0, sin(DoF3(4)),cos(DoF3(4)),0.5*DoF3(2);0,0,0,1];
A4=[cos(Theta(4)),-cos(DoF4(4))*sin(Theta(4)), sin(DoF4(4))*sin(Theta(4)),DoF4(3)*cos(Theta(4)); sin(Theta(4)), cos(DoF4(4))*cos(Theta(4)), -sin(DoF4(4))*cos(Theta(4)),DoF4(3)*sin(Theta(4));0, sin(DoF4(4)),cos(DoF4(4)),DoF4(2);0,0,0,1];
A4CDG=[cos(Theta(4)),-cos(DoF4(4))*sin(Theta(4)), sin(DoF4(4))*sin(Theta(4)),0.5*DoF4(3)*cos(Theta(4)); sin(Theta(4)), cos(DoF4(4))*cos(Theta(4)), -sin(DoF4(4))*cos(Theta(4)),0.5*DoF4(3)*sin(Theta(4));0, sin(DoF4(4)),cos(DoF4(4)),0.5*DoF4(2);0,0,0,1];
A5=[cos(Theta(5)),-cos(DoF5(4))*sin(Theta(5)), sin(DoF5(4))*sin(Theta(5)),DoF5(3)*cos(Theta(5)); sin(Theta(5)), cos(DoF5(4))*cos(Theta(5)), -sin(DoF5(4))*cos(Theta(5)),DoF5(3)*sin(Theta(5));0, sin(DoF5(4)),cos(DoF5(4)),DoF5(2);0,0,0,1];
A5CDG=[cos(Theta(5)),-cos(DoF5(4))*sin(Theta(5)), sin(DoF5(4))*sin(Theta(5)),0.5*DoF5(3)*cos(Theta(5)); sin(Theta(5)), cos(DoF5(4))*cos(Theta(5)), -sin(DoF5(4))*cos(Theta(5)),0.5*DoF5(3)*sin(Theta(5));0, sin(DoF5(4)),cos(DoF5(4)),0.5*DoF5(2);0,0,0,1];

%Definim les matrius necessaries per a fer el PLOT.
A1=A1;
A12=A1*A2;
A12CDG=A1*A2CDG;
A13=A12*A3;
A13CDG=A12*A3CDG;
A14=A13*A4;
A14CDG=A13*A4CDG;
A15=A14*A5;
A15CDG=A14*A5CDG;

CDG1=A1CDG(1:3,4);
CDG2=A12CDG(1:3,4);
CDG3=A13CDG(1:3,4);
CDG4=A14CDG(1:3,4);
CDG5=A15CDG(1:3,4);

%Clcul de la distncia del centre de gravetat de cada element del bra
%respecte al centre de gravetat actual del robot.
CDG1_=CDG1+XArm';
CDG2_=CDG2+XArm';
CDG3_=CDG3+XArm';
CDG4_=CDG4+XArm';
CDG5_=CDG5+XArm';

D=[CDG1_, CDG2_, CDG3_, CDG4_, CDG5_];
Super=[0,l1*l2+l3^2*0.1+l4^2*0.1+l5^2*0.1,Pextrem(1)*0.05,0,0,l1*l2+l3^2*0.1+l4^2*0.1+l5^2*0.1,Pextrem(1)*0.05,0];
centreBra=((D(:,1)*Super(1)+D(:,2)*Super(2)+D(:,3)*Super(3)+D(:,5)*Super(4))/(Super(1)+Super(2)+Super(3)+Super(4)));

InerciaGlobal=ISub;

for i=1:nArticulacions
x=D(1,i);
y=D(2,i);
z=D(3,i);
Inerciai=mArm(i)*[[z^2+y^2,-x*y,-x*z];[-y*x,x^2+z^2,-y*z];[-z*x,-z*y,x^2+y^2]];
InerciaGlobal=InerciaGlobal+Inerciai;
end
InerciaGlobal=1/g*InerciaGlobal;
%----------------------------------------------------------------------
%FI--CLCUL DE LA MATRIU TENSOR D'INRCIES DEL CONJUNT
%----------------------------------------------------------------------

%----------------------------------------------------------------------
%INICI--FUNCI DEL SUBMAR
%----------------------------------------------------------------------
%Flotabilitat i centre de flotabilitat
massaSub=(mSub+mArm(1)+mArm(2)+mArm(3)+mArm(5));
B=(mSub+mArm(1)+mArm(2)+mArm(3)+mArm(5))*g;
xb=0;
yb=0;
zb=0;

%Pes i centre de gravetat
W=massaSub*g;

xg=CDG(1);
yg=CDG(2);
zg=CDG(3);
xc=CDG(1);
yc=CDG(2);
zc=CDG(3);

%Inrcies del submar
Ix=InerciaGlobal(1,1);
Iy=InerciaGlobal(2,2);
Iz=InerciaGlobal(3,3);
Ixy=InerciaGlobal(1,2);
Ixz=-InerciaGlobal(1,3);
Iyz=InerciaGlobal(2,3);
Iyx=InerciaGlobal(2,1);
Izx=-InerciaGlobal(3,1);
Izy=InerciaGlobal(3,2);

%Coeficients de fricci del submar, Aquest parmetres s'han de
%modificar en funci de cada submar.
Xu=50;
Xuu=300;
Yv=50;
Yvv=300;
Zw=50;
Zww=300;
Kp=50;
Kpp=0;
Mq=50;
Mqq=0;
Nr=50;
Nrr=0;

%Masses afegides en el submar, Aquest parmetres s'han de
%modificar en funci de cada submar.
Xudot=-30;
Yvdot=-30;
Zwdot=-30;
Kpdot=0;
Mqdot=0;
Nrdot=0;

%Variables per facilitar el clcul
zero=zeros(3);
%--------------------------------------------------------------------------
%Angles de rotaci respecte la referncia absoluta al centre de gravetat
%del vehicle, PHI=4, THETA=5, PSI=6
phi=Rg(4);
cphi=cos(phi);
sphi=sin(phi);
theta=Rg(5);
cthe=cos(theta);
sthe=sin(theta);
tthe=tan(theta);
psi=Rg(6);
cpsi=cos(psi);
spsi=sin(psi);

%Matriu de rotaci de coordenades absolutes a relatives
%matriu de rotaci
matEG=[[cpsi*cthe,  -spsi*cphi+cpsi*sphi*sthe,  sphi*spsi+cphi*cpsi*sthe,   0,      0,          0];
    [spsi*cthe,     cpsi*cphi+spsi*sphi*sthe,  cphi*spsi*sthe-sphi*cpsi,   0,      0,          0];
    [-sthe,          sphi*cthe,                cphi*cthe,                  0,      0,          0];
    [0,             0,                          0,                          1,      sphi*tthe,  cphi*tthe];
    [0,             0,                          0,                          0,      cphi,       -sphi];
    [0,             0,                          0,                          0,      sphi/cthe,cphi/cthe]];

%Es defineix la velocitat en cada un dels graus de llibertat
%Vg=[u;v;w;p;q;r];

%Passem de les velocitat de terra a velocitat del vehicle
vlEG=Vg(1:3);
vlEG=matEG(1:3,1:3)^-1*vlEG;

vaEG=Vg(4:6);
vaEG=matEG(4:6,4:6)^-1*vaEG;
matGE=[[matEG(1:3,1:3)^-1,zero];[zero,matEG(4:6,4:6)^-1]];

%Matriu de forces en els motors, aquesta fora depn de la velocitat
%angular dels motors
X=ForcesMotors(1);
Y=ForcesMotors(2);
Z=ForcesMotors(3);
K=ForcesMotors(4);
M=ForcesMotors(5);
N=ForcesMotors(6);

%Si es considera noms la fora s
Fmotors=[X;Y;Z;K;M;N];
%Fmotors=[X;Y;Z;K;M;0];

%Definim les forces de flotabilitat del submar
Fflot=[B*sthe;  -cthe*sphi*B;   -cthe*cphi*B;   -yb*cthe*cphi*B+zb*cthe*sphi*B;     zb*sthe*B+xb*cthe*cphi*B;   -xb*cthe*sphi*B-yb*sthe*B];

%Definim les forces degudes a la gravetat
Fgrav=[-sthe*W;     cthe*sphi*W;       cthe*cphi*W;     yc*cthe*cphi*W-zc*cthe*sphi*W;  -zc*sthe*W-xc*cthe*cphi*W;  xc*cthe*sphi*W+yc*sthe*W];

%Es defineix G(O) com a la suma de Fflot i Fgrav, s'anomenar GO

GO=Fflot+Fgrav;

%Es defineix la matriu de coeficients de fricci linials i quadrtics
DVg=diag([Xu+Xuu*abs(Vg(1));Yv+Yvv*abs(Vg(2));Zw+Zww*abs(Vg(3));Kp+Kpp*abs(Vg(4));Mq+Mqq*abs(Vg(5));Nr+Nrr*abs(Vg(6))]);

%Es defineix la matriu de caracterstiques fsiques del vehicle anomenada
%gMrb
gMrb=[mSub,     0,              0,      0,              mSub*zg,        -mSub*yg;
    0,          mSub,           0,      -mSub*zg,       0,              mSub*xg;
    0,          0,              mSub,   mSub*yg,        -mSub*xg,       0;
    0,          -mSub*zg,       mSub*yg,Ix,             -Ixy,           -Ixz;
    mSub*zg,    0,              -mSub*xg,-Iyx,          Iy,             -Iyz;
    -mSub*yg,   mSub*xg,        0,      -Izx,           -Izy,           Iz];

%Es calcula la matriu de massa afegida anomenada Ma
Ma=diag([-Xudot;-Yvdot;-Zwdot;-Kpdot;-Mqdot;-Nrdot]);

%Es defineixen unes submatrius de gMrb i de Ma per a poder calcular els
%components de les matrius de coriolis.

%submatrius de gMrb
M11=gMrb(1:3,1:3);
M12=gMrb(1:3,4:6);
M21=gMrb(4:6,1:3);
M22=gMrb(4:6,4:6);

%Submatrius de Ma
A11=Ma(1:3,1:3);
A12=Ma(1:3,4:6);
A21=Ma(4:6,1:3);
A22=Ma(4:6,4:6);

%Es calculen les matrius resultants d'utilitzar l'operador S, anomenat Smat

%Matrius per a formar Crb
Crb12=-Smat(M11*vlEG+M12*vaEG);
Crb21=Crb12;
Crb22=-Smat(M21*vlEG+M22*vaEG);

%Matrius per a formar Ca
Ca12=-Smat(A11*vlEG+A12*vaEG);
Ca21=Ca12;
Ca22=-Smat(A21*vlEG+A22*vaEG);

%Es defineix la matriu GcRB(cV) anomenada Crb
Crb=[zero,Crb12;Crb21,Crb22];

%Es defineix la matriu Ca(gV) anomenada Ca
Ca=[zero,Ca12;Ca21,Ca22];

%Matriu de friccions hidrodinmiques del bra, on Ra=KSV^2
Cxx=0.1;
pespecific=1000;
Kfriccio=Cxx*pespecific/2*g;
Super=[0,l1*l2+l3^2*0.1+l4^2*0.1+l5^2*0.1,Pextrem(1)*0.05,0,0,l1*l2+l3^2*0.1+l4^2*0.1+l5^2*0.1,Pextrem(1)*0.05,0];

DBra=diag([Kfriccio*Super(1)*abs(vlEG(1));Kfriccio*Super(2)*abs(vlEG(2));Kfriccio*Super(3)*abs(vlEG(3));Kfriccio*Super(4)*abs(vaEG(1))*centreBra(1);Kfriccio*Super(5)*abs(vaEG(2))*centreBra(2);Kfriccio*Super(6)*abs(vaEG(3))*centreBra(3)]);
DBra=DBra*[vlEG;vaEG];
DBra=DBra+[0;0;0;DBra(2)*(centreBra(3));0.5*DBra(3)*centreBra(1);DBra(2)*centreBra(1)];

Compensa=[0;0;(mArm(1)+mArm(2)+mArm(3)+mArm(4)+mArm(5))*g;g*(CDG1(2)*mArm(1)+CDG2(2)*mArm(2)+CDG3(2)*mArm(3)+CDG4(2)*mArm(4)+CDG5(2)*mArm(5));g*(CDG1(1)*mArm(1)+CDG2(1)*mArm(2)+CDG3(1)*mArm(3)+CDG4(1)*mArm(4)+CDG5(1)*mArm(5));0];

signes=diag([1,-1,-1,1,-1,-1]);

FBase=signes*FBase;
FBra=FBase-Compensa;

FDist=[0;0;0;0;FBra(3)*XArm(1);0];
FBra=FBra+FDist;
signes2=diag([1,1,1,1,-1,1]);
FBra=signes2*FBra;

FBra2=FBra;
FBra=matGE*FBra;

%La equaci de Fossen s la definida
%T+GO-DVg*Vg+Pe=(gMrb+Ma)*Vg_dot+(Crb+Ca)*Vg, es suposa Pe=0

Vg_dot=(gMrb+Ma)^(-1)*(Fmotors-DBra+FBra+GO-DVg*[vlEG;vaEG]-(Crb+Ca)*[vlEG;vaEG]);

%Vg en coordenades del vehicle la sumem a la nova velocitat proporcionada
%per la integral de Vg_dot*Ts on Vg_dot est en coordenades del vehicle.
Vg=[vlEG;vaEG];
Vg=Vg+Vg_dot*Ts;
Vg=matEG*Vg;
Rg=Rg+Vg*Ts;
gdot_=Vg_dot';
Vg_=Vg';
Rg_=Rg';
ConsBra=FBra2-DBra;

%----------------------------------------------------------------------
%FI--FUNCI DEL SUBMAR
%----------------------------------------------------------------------
sortida=[Q_sortida',Rg',Vg',Fgrav',POS_bra',Error_anterior,Fmotors',CDG',ConsBra',gdot_];

end